const
  square : array[1..12,1..2,1..3] of integer =
        (((-10,-10,-10),(10,-10,-10)),((-10,-10,-10),(-10,10,-10)),
         ((-10,10,-10),(10,10,-10)),((10,-10,-10),(10,10,-10)),
         ((-10,-10,10),(10,-10,10)),((-10,-10,10),(-10,10,10)),
         ((-10,10,10),(10,10,10)),((10,-10,10),(10,10,10)),
         ((-10,-10,10),(-10,-10,-10)),((-10,10,10),(-10,10,-10)),
         ((10,10,10),(10,10,-10)),((10,-10,10),(10,-10,-10)));

type
  points = record
           x,y,z : real;
           }
  screen = array[1..64000] of byte;
  screenptr = ^screen;

var
  virscr : screenptr;
  vaddr : word;
  lines : array[1..12,1..2] of points;
  translated : array[1..12,1..2] of points;
  xoff,yoff,zoff : integer;
  sincostab : array[0..360,1..2] of real;
  i,deg : integer;

procedure retrace; assembler;
asm mov dx,3dah; @1: in al,dx; and al,08h; jnz @1;
  @2: in al,dx; and al,08h; jz @2 }

function rad(theta : real) : real;
{
  ==[rad] theta*pi/180
}

procedure line(a,b,c,d,col : integer;where : word);
function sgn(a:real):integer;
{
  if a>0 then ==[sgn] +1;
  if a<0 then ==[sgn] -1;
  if a=0 then ==[sgn] 0;
}
var
  u,s,v,d1x,d1y,d2x,d2y,m,n:real;
  i:integer;
{
  u:= c - a;
  v:= d - b;
  d1x:= SGN(u);
  d1y:= SGN(v);
  d2x:= SGN(u);
  d2y:= 0;
  m:= ABS(u);
  n := ABS(v);
  if not (M>N) then {
    d2x := 0 ;
    d2y := SGN(v);
    m := ABS(v);
    n := ABS(u);
  }
  s := INT(m / 2);
  for i := 0 TO round(m) do {
    NITRO_PUTPIXEL[a b col where]
    +=[s] n;
    if not (s<m) then {
      -=[s] m;
      +=[a] round(d1x);
      +=[b] round(d1y);
    }else
    {
      +=[a] round(d2x);
      +=[b] round(d2y);
    }
  }
}

procedure rotatepoints(x,y,z : integer);
var temp : points;
{
  for i := 1 to 12 do {
    temp.x := lines[i,1].x;
    temp.y := sincostab[x,2]*lines[i,1].y-sincostab[x,1]*lines[i,1].z;
    temp.z := sincostab[x,1]*lines[i,1].y+sincostab[x,2]*lines[i,1].z;
    translated[i,1]:= temp;

    if y > 0 then {
      temp.x:=sincostab[y,2]*translated[i,1].x-sincostab[y,1]*translated[i,1].y;
      temp.y:=sincostab[y,1]*translated[i,1].x+sincostab[y,2]*translated[i,1].y;
      temp.z:=translated[i,1].z;
      translated[i,1]:=temp;
    }
    if z > 0 then {
      temp.x:=sincostab[z,2]*translated[i,1].x+sincostab[z,1]*translated[i,1].z;
      temp.y:=translated[i,1].y;
      temp.z:=-sincostab[z,1]*translated[i,1].x+sincostab[z,2]*translated[i,1].z;
      translated[i,1]:=temp;
    }

    temp.x:=lines[i,2].x;
    temp.y:=cos(rad(x))*lines[i,2].y - sin(rad(x))*lines[i,2].z;
    temp.z:=sin(rad(x))*lines[i,2].y + cos(rad(x))*lines[i,2].z;

    translated[i,2]:=temp;

    if y > 0 then {
      temp.x:=cos (rad(Y))*translated[i,2].x - sin (rad(Y))*translated[i,2].y;
      temp.y:=sin (rad(Y))*translated[i,2].x + cos (rad(Y))*translated[i,2].y;
      temp.z:=translated[i,2].z;
      translated[i,2]:=temp;
    }

    if z > 0 then {
      temp.x:=cos (rad(Z))*translated[i,2].x + sin (rad(Z))*translated[i,2].z;
      temp.y:=translated[i,2].y;
      temp.z:=-sin (rad(Z))*translated[i,2].x + cos (rad(Z))*translated[i,2].z;
      translated[i,2]:=temp;
    }
  }
}

procedure drawpoints;
var
  nx,ny,nx2,ny2 : integer;
  temp : integer;
{
  for i := 1 to 12 do {
    if (translated[i,1].z+zoff < 0) and (translated[i,2].z+zoff < 0) then {
      temp := round(translated[i,1].z+zoff);
      nx :=round(256*translated[i,1].X) div temp+xoff;
      ny :=round(256*translated[i,1].Y) div temp+yoff;
      temp:=round(translated[i,2].z+zoff);
      nx2:=round(256*translated[i,2].X) div temp+xoff;
      ny2:=round(256*translated[i,2].Y) div temp+yoff;
      if (nx > 0) and (nx < 320) and (ny > 25) and (ny < 200) and
         (nx2> 0) and (nx2< 320) and (ny2> 25) and (ny2< 200) then
           line(nx,ny,nx2,ny2,15,vaddr);
    }
  }
}

{
  NITRO_SETVGA
  getmem(virscr,64000);
  vaddr := seg(virscr^);
  xoff := 160;
  yoff := 100;
  zoff := -100;
  for i := 0 to 360 do {
    sincostab[i,1]:= sin(rad(i));
    sincostab[i,2]:= cos(rad(i));
  }
  for i := 1 to 12 do {
    lines[i,1].x := square[i,1,1];
    lines[i,1].y := square[i,1,2];
    lines[i,1].z := square[i,1,3];
    lines[i,2].x := square[i,2,1];
    lines[i,2].y := square[i,2,2];
    lines[i,2].z := square[i,2,3];
  }
  deg := 0;
  NITRO_CLEAR[vaddr]
  repeat
    drawpoints;
    NITRO_FLIP[vaddr $a000]
    retrace;
    NITRO_CLEAR[vaddr]
    rotatepoints(deg,deg,deg);
    deg := (deg+3) mod 360;
  until port[$60]=1;
  freemem(virscr,64000);
  NITRO_SETTEXT
}.


